﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace regnav
{
    class Program
    {
        // must be [STAThread] to get clipboard data
        [STAThread]
        static void Main(string[] args)
        {

            string keyName = String.Join(" ", args);
            
            if (keyName.Length == 0) {
                keyName = System.Windows.Forms.Clipboard.GetText();
                if (keyName.Length < 4 || keyName.Substring(0, 4) != "HKEY")
                {
                    Console.WriteLine("Syntax:  regat [KEYNAME]");
                    Console.WriteLine("          (KEYNAME may be omitted if there is a key in the clipboard)");
                    Console.WriteLine("");
                    Console.WriteLine("You may abbreviate using HKCR, HKCU, HKLM, HKU, HKCC");
                    Console.WriteLine("");
                    Console.WriteLine("regat.exe v0.2    Apr 23 2015");
                    Console.WriteLine("See http://www.elifulkerson.com for updates.");
                    
                    Environment.Exit(1);
                }
            }


            // some lazy replacements

            if (keyName.Substring(0, 4) == "HKCR")
            {
                keyName = keyName.Substring(4);
                keyName = "HKEY_CLASSES_ROOT" + keyName;
            }

            if (keyName.Substring(0, 4) == "HKCU")
            {
                keyName = keyName.Substring(4);
                keyName = "HKEY_CURRENT_USER" + keyName;
            }

            if (keyName.Substring(0, 4) == "HKLM")
            {
                keyName = keyName.Substring(4);
                keyName = "HKEY_LOCAL_MACHINE" + keyName;
            }

            if (keyName.Substring(0, 4) == "HKU")
            {
                keyName = keyName.Substring(3);
                keyName = "HKEY_CUSERS" + keyName;
            }

            if (keyName.Substring(0, 4) == "HKCC")
            {
                keyName = keyName.Substring(4);
                keyName = "HKEY_CURRENT_CONFIG" + keyName;
            }

            const string lastkey = "HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Applets\\Regedit";
            Registry.SetValue(lastkey, "Lastkey", keyName);

            try
            {
                System.Diagnostics.Process.Start("regedit.exe");
            } 
            catch( Exception e) 
            {
                Console.WriteLine(e.Message);
                Environment.Exit(1);
            }
            Environment.Exit(0);
            
        }
    }
}
